#! /usr/bin/perl
# MultiSeti. Seti@Home Utility. Copyright (C) 1999-2000. Vlatko Kosturjak.
# E-mail: kost@iname.com                                http://k0st.cjb.net
# Distributed under GPL. 

$num_setis = 5; # number of seti packets to download/work in one session
$work_cmdline = "setiathome -stop_after_process"; # cmdline for working
$connect_cmdline = "setiathome -stop_after_xfer"; # cmdline for receive/send

# to enable auto log-on just put your e-mail address and  uncomment it
# $login_email = "kost\@iname.com";	# e-mail for auto log-on

$archivename = "setiarch.tgz"; 				# name of archive
$archcmdline = "tar czf $archivename ";   # cmdline for arch
$unarchcmdline = "tar xzf $archivename "; # cmdline for unarch

$version="v0.6";						# version of MultiSeti
$working_filename = "work_unit.txt";
$working_filename2= "work_unit.sah";	# for setiathome v2.0 +
$result_filename = "result.txt";
$result_filename2= "result.sah";		# for setiathome v2.0 +
$state_filename = "state.txt";
$state_filename = "state.sah";			# for setiathome v2.0 +

# sort by modification time
sub bymtime {
	($num1,$mtime1) = split(":",$a);
	($num2,$mtime2) = split(":",$b);
	$mtime1 <=> $mtime2;
}

# returns how many seti packets are left from working filename
sub howmanywpackets {
	my $numoftodo = 0;
	for ($i = 1; $i <= $num_setis; $i++)
	{
		chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
		$rez1 = stat ($working_filename);
		$rez2 = stat ($working_filename2);
		$rez=$rez1 || $rez2;
		$numoftodo+=1 if ($rez);
		chdir "..";
	}
	return $numoftodo
}

# returns how many seti packets are left from results filename
sub howmanyrpackets {
	my $numoftodo = 0;
	for ($i = 1; $i <= $num_setis; $i++)
	{
		chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
		$rez1 = stat ($result_filename);
		$rez2 = stat ($result_filename2);
		$rez=$rez1 || $rez2;
		$numoftodo+=1 if ($rez);
		chdir "..";
	}
	return $numoftodo
}
print "MultiSeti $version. Seti\@Home Utility. Copyright (C) 1999-2001 Vlatko Kosturjak.\n";
print "            Distributed under GPL. See 'COPYING' for details.\n\n";

$command = shift;
$temp_num = shift;
if ($temp_num)
{
	$num_setis=$temp_num;
}

print "---> Number of seti packets per session: $num_setis\n";

if ($command)
{
	if ($command eq "init")
	{
		print "---> Initializing...\n";
		print "---> Making directories($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			mkdir $i, 0777;
			print "*";
		}
		print "...ok\n";
	}
	if ($command eq "del")
	{
		print "---> Deleting...\n";
		print "---> Deleting directories($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
		{
	    		rmdir $i;
	    		print "*";
	  	}
		print "...ok\n";
	}
	if ($command eq "tar")
	{
		$alldirs=$archcmdline;
		print "---> TARing...\n";
		print "---> Processing directories($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
		{
		    $alldirs=$alldirs."$i ";			
			print "*";
		}
		print "...ok\n";
		print "---> Invoking: ".$alldirs."\n";
	    system ($alldirs);
	}
	if ($command eq "untar")
	{
		$alldirs=$unarchcmdline;
		print "---> UNTARing...\n";
		print "---> Processing directories($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			$alldirs=$alldirs."$i ";			
			print "*";
		}
		print "...ok\n";
		print "---> Invoking: ".$alldirs."\n";
		system ($alldirs);
	}
	if ($command eq "wipe")
	{
		print "---> Wipe...\n";
		print "---> Directory wipe($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			$heh = `rm -rf $i `;
			print "*";
		}
		print "...ok\n";
	}
	if ($command eq "work")
	{
		print "---> Working...\n";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			print "---> Looking $i seti...";
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			do
			{
				$rez1 = stat ($working_filename);
				$rez2 = stat ($working_filename2);
				$rez=$rez1 || $rez2;
				if ($rez)
				{
					print "v2." if ($rez2);
					print "found.\n";
					print "---> Executing: $work_cmdline\n";
					$torestart=0;
					system $work_cmdline;	
					$exit_value = $ ? >>8;
					print "Exit Value: $exit_value\n";
					$signal_num = $ ? &127;
					print "Signal Number: $signal_num\n";
					$dumped_core = $ ? &128;
					if ($dumped_core)
					{
					   print "---> Huh! Seti\@Home client dumped core. Restarting...\n";
					   $torestart=1;
					}
					print "Dumped core: $dumped_core\n";
					die "---> Break signal detected! Aborting!\n" if ($signal_num == 2);
				}
				else
				{
					print "not found!\n";
				}
			}
			while ($torestart==1);

			chdir "..";
		}
		print "---> *** ALL DATA PACKETS FINISHED ($num_setis) ***\n";
	}
	if ($command eq "connect")
	{
		print "---> Sending Results/Receiving new data packets...\n";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			print "---> Looking $i seti...";
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			$rez = stat ($working_filename) || stat($working_filename2);
			if ($rez)
			{
				print "this unit not finished yet! skipping\n";
			}
			else
			{
				$rez = stat ($result_filename) || stat ($result_filename2);
				if ($rez)
				{
					print "found result.\n";
				}
				else
				{
					print "new entry. downoading data!\n";
				}
				if ($login_email)
				{
					print "---> Autologin: using e-mail: $login_email\n";
					$connect_cmdline="echo -e \"2\\n$login_email\" |".$connect_cmdline;
				}
				print "---> Executing: $connect_cmdline\n";
				system $connect_cmdline;
				$exit_value = $ ? >>8;
				print "Exit Value: $exit_value\n";
				$signal_num = $ ? &127;
				print "Signal Number: $signal_num\n";
				$dumped_core = $ ? &128;
				print "Dumped core: $dumped_core\n";
			}
			chdir "..";
		}
		print "---> *** ALL DATA PACKETS SENT/RECEIVED ($num_setis) ***\n";
	}
	if ($command eq "status")
	{
		print "---> Status Request...\n";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			printf "---> Looking %3d seti: ",$i;
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			$rez1 = stat ($state_filename);
			$rez2 = stat ($state_filename2);
			$rez = $rez1 || $rez2;
			if ($rez)
			{
				if ($rez1)
				{
					print "v1...";
					open(STATE, $state_filename) || 
                         die "---> Error: Cannot open state file\n";
				}
				else
				{
					print "v2...";
					open(STATE, $state_filename2) ||
						die "---> Error: Cannot open state file (v2)\n";
				} 
        $ncfft = <STATE>;
          chomp($ncfft);
        $cr = <STATE>;
          chomp($cr);
        $fl = <STATE>;
          chomp($fl);
        $cpu = <STATE>;
          chomp($cpu);
        $prog = <STATE>;
          chomp($prog);
        $bs_power = <STATE>;
          chomp($bs_power);
        $bs_score = <STATE>;
          chomp($bs_score);
        $bs_bin = <STATE>;
          chomp($bs_bin);
        $bs_fft_ind = <STATE>;
          chomp($bs_fft_ind);
        $bs_chirp_rate = <STATE>;
          chomp($bs_chirp_rate);
        $bs_fft_len = <STATE>;
          chomp($bs_fft_len);
        $bg_score = <STATE>;
          chomp($bg_score);
        $bg_power = <STATE>;
          chomp($bg_power);
        $bg_chisq = <STATE>;
          chomp($bg_chisq);
        $bg_bin = <STATE>;
          chomp($bg_bin);
        $bg_fft_ind = <STATE>;
          chomp($bg_fft_ind);
        $bg_chirp_rate = <STATE>;
          chomp($bg_chirp_rate);
        $bg_fft_len = <STATE>;
          chomp($bg_fft_len);

				close(STATE) || die "---> Error: Cannot close state file\n";
				($prog_temp, $prog_value) = split(/=/, $prog);
				$unitprog = ($prog_value * 100);
				printf "%07.4f ", $unitprog;
				print "\% done ";
			}
			else
			{
				print "not found! ";
			}
			
			$rez1 = stat ($result_filename);
			$rez2 = stat ($result_filename2);
			$rez = $rez1 || $rez2;
#			print "v1.." if ($rez1);
#			print "v2.." if ($rez2);
			if ($rez)
			{
				print "(finished - waiting for connection)\n";
			}
			else
			{
				print "(still needs to work)\n";
			}

		chdir "..";
		}
    	print "---> *** ALL DATA PACKETS LISTED ($num_setis) ***\n";
	}
	if ($command eq "brief")
	{
		print "MultiSeti BEGIN\n";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			printf "%d: ",$i;
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			$rez1 = stat ($state_filename);
			$rez2 = stat ($state_filename2);
			$rez = $rez1 || $rez2;
			if ($rez)
			{
				if ($rez1)
				{
					open(STATE, $state_filename) || 
						 die "---> Error: Cannot open state file\n";
				}
				else
				{
					open(STATE, $state_filename2) ||
						die "---> Error: Cannot open state file (v2)\n";
				} 
		$ncfft = <STATE>;
		  chomp($ncfft);
		$cr = <STATE>;
		  chomp($cr);
		$fl = <STATE>;
		  chomp($fl);
		$cpu = <STATE>;
		  chomp($cpu);
		$prog = <STATE>;
		  chomp($prog);
		$bs_power = <STATE>;
		  chomp($bs_power);
		$bs_score = <STATE>;
		  chomp($bs_score);
		$bs_bin = <STATE>;
		  chomp($bs_bin);
		$bs_fft_ind = <STATE>;
		  chomp($bs_fft_ind);
		$bs_chirp_rate = <STATE>;
		  chomp($bs_chirp_rate);
		$bs_fft_len = <STATE>;
		  chomp($bs_fft_len);
		$bg_score = <STATE>;
		  chomp($bg_score);
		$bg_power = <STATE>;
		  chomp($bg_power);
		$bg_chisq = <STATE>;
		  chomp($bg_chisq);
		$bg_bin = <STATE>;
		  chomp($bg_bin);
		$bg_fft_ind = <STATE>;
		  chomp($bg_fft_ind);
		$bg_chirp_rate = <STATE>;
		  chomp($bg_chirp_rate);
		$bg_fft_len = <STATE>;
		  chomp($bg_fft_len);

				close(STATE) || die "---> Error: Cannot close state file\n";
				($prog_temp, $prog_value) = split(/=/, $prog);
				$unitprog = ($prog_value * 100);
				printf "%07.4f ", $unitprog;
				print "\% ";
			}
			else
			{
				print "!";
			}
			
			$rez1 = stat ($result_filename);
			$rez2 = stat ($result_filename2);
			$rez = $rez1 || $rez2;
#			print "v1.." if ($rez1);
#			print "v2.." if ($rez2);
			if ($rez)
			{
				print "(f)\n";
			}
			else
			{
				print "(w)\n";
			}

		chdir "..";
		}
		print "MultiSeti END\n";
		print "TOTAL: ($num_setis) \n";
		print "! = not found, (f) = finished, (w) = still to work\n";
	}
	if ($command eq "timework")
	{
		print "---> Start to work on packets, but on oldest one first\n";
		while (howmanywpackets()!=0)
		{
			print "---> Previewing... ";
			for ($i = 1; $i <= $num_setis; $i++)
			{
				print "$i:";
				chdir "$i";
				($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
				$atime,$mtime,$ctime,$blksize,$blocks)
				= stat($working_filename2);
				push @packets, "$i:$mtime";
				chdir "..";
			}
			print "\n";

			print "---> Working on oldest one first... \n";
			@packets = sort bymtime @packets;
			($i,$mtime) = split(":",$packets[0]);
			print "---> Looking $i seti...";
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			do
			{
				$rez1 = stat ($working_filename);
				$rez2 = stat ($working_filename2);
				$rez=$rez1 || $rez2;
				if ($rez)
				{
					if ($rez2)
					{
						print "v2.";
					}
					print "found.\n";
					print "---> Executing: $work_cmdline\n";
					$torestart=0;
					system $work_cmdline;	
					$exit_value = $ ? >>8;
					print "Exit Value: $exit_value\n";
					$signal_num = $ ? &127;
					print "Signal Number: $signal_num\n";
					$dumped_core = $ ? &128;
					if ($dumped_core)
					{
					   print "---> Huh! Seti\@Home client dumped core. Restarting...\n";
					   $torestart=1;
					}
					print "Dumped core: $dumped_core\n";
					die "---> Break signal detected! Aborting!\n" if ($signal_num == 2);
				}
				else
				{
					print "not found!\n";
				}
			}
			while ($torestart==1);
			chdir "..";
		}

		print "---> *** ALL DATA PACKETS FINISHED OR THERE'S NOTHING TO WORK ***\n";
	}
	if ($command eq "timecon")
	{
		print "---> Sending/Receiving packets, but oldest one first\n";

		while (howmanyrpackets()!=0)
		{
			print "---> Previewing... ";
			for ($i = 1; $i <= $num_setis; $i++)
			{
				print "$i:";
				chdir "$i";
				($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
				$atime,$mtime,$ctime,$blksize,$blocks)
				= stat($result_filename2);
				push @packets, "$i:$mtime";
				chdir "..";
			}
			print "\n";

			print "---> Working on oldest one first... \n";
			@packets = sort bymtime @packets;
			($i,$mtime) = split(":",$packets[0]);
			print "---> Looking $i seti...";
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			$rez = stat ($working_filename) || stat($working_filename2);
			if ($rez)
			{
				print "this unit not finished yet! skipping\n";
			}
			else
			{
				$rez = stat ($result_filename) || stat ($result_filename2);
				if ($rez)
				{
					print "found result.\n";
				}
				else
				{
					print "new entry. downoading data!\n";
				}
				if ($login_email)
				{
					print "---> Autologin: using e-mail: $login_email\n";
					$connect_cmdline="echo -e \"2\\n$login_email\" |".$connect_cmdline;
				}
				print "---> Executing: $connect_cmdline\n";
				system $connect_cmdline;
				$exit_value = $ ? >>8;
				print "Exit Value: $exit_value\n";
				$signal_num = $ ? &127;
				print "Signal Number: $signal_num\n";
				$dumped_core = $ ? &128;
				print "Dumped core: $dumped_core\n";
			}
			chdir "..";
		}
		print "---> *** ALL DATA PACKETS SENT/RECEIVED OR THERE'S NOTHING TO DO ***\n";
	}
}
else
{
	print "use: multiseti.pl <command> [number]\n\n";
	print "Command: init     - make directories for multiple setis\n";
	print "         connect  - download data & send results (if any)\n";
	print " (new!)  timecon  - download data & send results but oldest packet first\n";
	print "         work     - start to work!\n";
	print " (new!)  timework - start to work but on oldest packet first\n";
	print "         status   - display progress of seti packets\n";
	print "         brief    - display brief progress of seti packets\n";
	print "         tar      - make tar archive of seti packets\n";
	print "         untar    - unpack tar archive of seti packets\n";
	print "         del      - delete directories (only works if dirs are empty)\n";
	print "         wipe     - delete directories with files in dirs\n\n";
	print "Number:  (optional) number of seti packets for one session (default: $num_setis)\n";

	print "\n";
}

