#! /usr/bin/perl
# MultiSeti. Seti@Home Utility. Copyright (C) 1999-2000. Vlatko Kosturjak.
# E-mail: kost@iname.com                                http://k0st.cjb.net
# Distributed under GPL. 

$num_setis = 5;                 # number of seti packets to download/work in one session
$touchbin="/bin/touch";		# location of 'touch' utility
@work_cmdline = ("setiathome", "-stop_after_process"); # cmdline for working
@connect_cmdline = ("setiathome", "-stop_after_xfer"); # cmdline for receive/send

# to enable auto log-on just put your e-mail address and  uncomment it
# $login_email = "kost\@iname.com";     # e-mail for auto log-on

$archivename = "setiarch.tgz";            # name of archive
$archcmdline = "tar czf $archivename ";   # cmdline for arch
$unarchcmdline = "tar xzf $archivename "; # cmdline for unarch


$version="v0.5";                # version of MultiSeti
$working_filename = "work_unit.txt";
$working_filename2= "work_unit.sah";    # for setiathome v2.0
$result_filename = "result.txt";
$result_filename2= "result.sah";                # for setiathome v2.0
$state_filename = "state.txt";
$state_filename = "state.sah";                  # for setiathome v2.0


$command = shift;
$temp_num = shift;

$num_parallel=1;
$num_running=0;
$child_pid = 0;
$| = 1;

$SIG{CHLD} = sub { wait };

sub catch_sig
{
    kill 9, $child_pid if ($child_pid > 0 && kill 0, $child_pid);
    $child_pid = 0;
    exit 0;
}
$SIG{INT} = \&catch_sig;
$SIG{QUIT} = \&catch_sig;
$SIG{HUP} = \&catch_sig;


if ($temp_num)
{
	$num_setis=$temp_num;
}


if ($command)
{
	if ($command eq "init")
        {
		print "---> Initializing...\n";
		print "---> Making directories($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
        	{
			mkdir $i, 0777;
			print "*";
        	}	
		print "...ok\n";
        }
	if ($command eq "del")
        {
		print "---> Deleting...\n";
		print "---> Deleting directories($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
        	{
        	    rmdir $i;
        	    print "*";
        	}
		print "...ok\n";
        }
	if ($command eq "wipe")
        {
		print "---> Wipe...\n";
		print "---> Directory wipe($num_setis)...";
		for ($i = 1; $i <= $num_setis; $i++)
        	{	
			$heh = `rm -rf $i `;
			print "*";
        	}	
		print "...ok\n";
        }
       if ($command eq "tar")
        {
                $alldirs=$archcmdline;
                print "---> TARing...\n";
                print "---> Processing directories($num_setis)...";
                for ($i = 1; $i <= $num_setis; $i++)
                {
                    $alldirs=$alldirs."$i ";
                        print "*";
                }
                print "...ok\n";
                print "---> Invoking: ".$alldirs."\n";
            system ($alldirs);
        }
        if ($command eq "untar")
        {
                $alldirs=$unarchcmdline;
                print "---> UNTARing...\n";
                print "---> Processing directories($num_setis)...";
                for ($i = 1; $i <= $num_setis; $i++)
                {
                        $alldirs=$alldirs."$i ";
                        print "*";
                }
                print "...ok\n";
                print "---> Invoking: ".$alldirs."\n";
                system ($alldirs);
        }
	if ($command eq "work")
        {
		for ($i = 1; $i <= $num_setis && $num_running < $num_parallel; $i++)
        	{

			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
            
			if ((-s $working_filename || -s $working_filename)&& ! (-s $result_filename || -s $result_filename2))
			{
                
            		    if (open(PID, "seti.pid"))
                	    {
                		$seti_pid=<PID>;
                		chop $seti_pid;
                		close PID;
                    
                		if (kill 0, $seti_pid)
                    		{
                    		    if ((stat("runseti.touch"))[9] > (stat($state_filename))[9])
                        	    {
                        		print `date`;
                        		print "Setiathome running but not processing\n";
                        		kill 9, $seti_pid;
                        	    }
                    		    else
                        	    {
                        		$num_running++;
                        		next;
                        	    }
                    		}
                	    }

			    print "---> Executing: ", @work_cmdline, "\n";
			    `$touchbin runseti.touch`;
            		    if ($pid = fork())
                	    {
                		if (open(PID, ">seti.pid"))
                    		{
                    		    print PID "$pid\n";
                    		    close PID;
                    		}
                	    }
            		    else
                	    {
                		close STDOUT;
                		close STDIN;
                		close STDERR;
                		exec @work_cmdline;
                	    }
            		    $num_running++;
            		}
			chdir "..";
        	    }

    		    exit 100 if ($num_running == 0);
          
        }
	if ($command eq "connect")
        {
		print "---> Sending Results/Receiving new data packets...\n";
        `/bin/touch multiseti.connect`;
        $num_running = 0;
        
		for ($i = 1; $i <= $num_setis; $i++)
            {
			print "---> Looking $i seti...";
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			if (( -s $working_filename) || (-s $working_filename2))
                {
				print "this unit not finished yet! skipping\n";
                }
			else
                {
                if ((-s $result_filename) || (-s $result_filename2))
                    {
					print "found result.\n";
                    }
				else
                    {
					print "new entry. downoading data!\n";
                    }
                unless ($child_pid = fork())
                    {
                    close STDOUT;
                    close STDIN;
                    close STDERR;
                    exec @connect_cmdline;
                    }
                waitpid($child_pid, 0);
                $child_pid = 0;
				$exit_value = $? >> 8;
				print "Exit Value: $exit_value\n";
				$signal_num = $? & 127;
				print "Signal Number: $signal_num\n";
				$dumped_core = $? &128;
				print "Dumped core: $dumped_core\n";
                $num_running = 1 if ($exit_value > 0 || $signal_num > 0)
                }
			chdir "..";
            }
        unlink "multiseti.connect" unless ($num_running);
        
		print "---> *** ALL DATA PACKETS SENT/RECEIVED ($num_setis) ***\n";
        }
	if ($command eq "status")
	{
		print "---> Status Request...\n";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			printf "---> Looking %3d seti: ",$i;
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			$rez1 = stat ($state_filename);
			$rez2 = stat ($state_filename2);
			$rez = $rez1 || $rez2;
			if ($rez)
			{
				if ($rez1)
				{
					print "v1...";
					open(STATE, $state_filename) || 
						 die "---> Error: Cannot open state file\n";
				}
				else
				{
					print "v2...";
					open(STATE, $state_filename2) ||
						die "---> Error: Cannot open state file (v2)\n";
				} 
		$ncfft = <STATE>;
		  chomp($ncfft);
		$cr = <STATE>;
		  chomp($cr);
		$fl = <STATE>;
		  chomp($fl);
		$cpu = <STATE>;
		  chomp($cpu);
		$prog = <STATE>;
		  chomp($prog);
		$bs_power = <STATE>;
		  chomp($bs_power);
		$bs_score = <STATE>;
		  chomp($bs_score);
		$bs_bin = <STATE>;
		  chomp($bs_bin);
		$bs_fft_ind = <STATE>;
		  chomp($bs_fft_ind);
		$bs_chirp_rate = <STATE>;
		  chomp($bs_chirp_rate);
		$bs_fft_len = <STATE>;
		  chomp($bs_fft_len);
		$bg_score = <STATE>;
		  chomp($bg_score);
		$bg_power = <STATE>;
		  chomp($bg_power);
		$bg_chisq = <STATE>;
		  chomp($bg_chisq);
		$bg_bin = <STATE>;
		  chomp($bg_bin);
		$bg_fft_ind = <STATE>;
		  chomp($bg_fft_ind);
		$bg_chirp_rate = <STATE>;
		  chomp($bg_chirp_rate);
		$bg_fft_len = <STATE>;
		  chomp($bg_fft_len);

				close(STATE) || die "---> Error: Cannot close state file\n";
				($prog_temp, $prog_value) = split(/=/, $prog);
				$unitprog = ($prog_value * 100);
				printf "%07.4f ", $unitprog;
				print "\% done ";
			}
			else
			{
				print "not found! ";
			}
			
			$rez1 = stat ($result_filename);
			$rez2 = stat ($result_filename2);
			$rez = $rez1 || $rez2;
#			print "v1.." if ($rez1);
#			print "v2.." if ($rez2);
			if ($rez)
			{
				print "(finished - waiting for connection)\n";
			}
			else
			{
				print "(still needs to work)\n";
			}

		chdir "..";
		}
		print "---> *** ALL DATA PACKETS LISTED ($num_setis) ***\n";
	}
	if ($command eq "brief")
	{
		print "MultiSeti BEGIN\n";
		for ($i = 1; $i <= $num_setis; $i++)
		{
			printf "%d: ",$i;
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
			$rez1 = stat ($state_filename);
			$rez2 = stat ($state_filename2);
			$rez = $rez1 || $rez2;
			if ($rez)
			{
				if ($rez1)
				{
					open(STATE, $state_filename) || 
						 die "---> Error: Cannot open state file\n";
				}
				else
				{
					open(STATE, $state_filename2) ||
						die "---> Error: Cannot open state file (v2)\n";
				} 
		$ncfft = <STATE>;
		  chomp($ncfft);
		$cr = <STATE>;
		  chomp($cr);
		$fl = <STATE>;
		  chomp($fl);
		$cpu = <STATE>;
		  chomp($cpu);
		$prog = <STATE>;
		  chomp($prog);
		$bs_power = <STATE>;
		  chomp($bs_power);
		$bs_score = <STATE>;
		  chomp($bs_score);
		$bs_bin = <STATE>;
		  chomp($bs_bin);
		$bs_fft_ind = <STATE>;
		  chomp($bs_fft_ind);
		$bs_chirp_rate = <STATE>;
		  chomp($bs_chirp_rate);
		$bs_fft_len = <STATE>;
		  chomp($bs_fft_len);
		$bg_score = <STATE>;
		  chomp($bg_score);
		$bg_power = <STATE>;
		  chomp($bg_power);
		$bg_chisq = <STATE>;
		  chomp($bg_chisq);
		$bg_bin = <STATE>;
		  chomp($bg_bin);
		$bg_fft_ind = <STATE>;
		  chomp($bg_fft_ind);
		$bg_chirp_rate = <STATE>;
		  chomp($bg_chirp_rate);
		$bg_fft_len = <STATE>;
		  chomp($bg_fft_len);

				close(STATE) || die "---> Error: Cannot close state file\n";
				($prog_temp, $prog_value) = split(/=/, $prog);
				$unitprog = ($prog_value * 100);
				printf "%07.4f ", $unitprog;
				print "\% ";
			}
			else
			{
				print "!";
			}
			
			$rez1 = stat ($result_filename);
			$rez2 = stat ($result_filename2);
			$rez = $rez1 || $rez2;
#			print "v1.." if ($rez1);
#			print "v2.." if ($rez2);
			if ($rez)
			{
				print "(f)\n";
			}
			else
			{
				print "(w)\n";
			}

		chdir "..";
		}
		print "MultiSeti END\n";
		print "TOTAL: ($num_setis) \n";
		print "! = not found, (f) = finished, (w) = still to work\n";
	}
	if ($command eq "oldstat")
        {
		print "---> Status Request...\n";
		for ($i = 1; $i <= $num_setis; $i++)
            {
			print "---> Looking $i seti...";
			chdir $i or die "---> Error: Cannot chdir to $i - use command init\n";
                
                        $rez1 = stat ($state_filename);
                        $rez2 = stat ($state_filename2);
                        $rez = $rez1 || $rez2;
                        if ($rez)
                        {
                                if ($rez1)
                                {
                                        print "v1...";
                                        open(STATE, $state_filename) ||
                         die "---> Error: Cannot open state file\n";
                                }
                                else
                                {
                                        print "v2...";
                                        open(STATE, $state_filename2) ||
                            die "---> Error: Cannot open state file (v2)\n";
                                }

                $ncfft = <STATE>;
                chomp($ncfft);
                $cr = <STATE>;
                chomp($cr);
                $fl = <STATE>;
                chomp($fl);
                $cpu = <STATE>;
                chomp($cpu);
                $prog = <STATE>;
                chomp($prog);
                $bs_power = <STATE>;
                chomp($bs_power);
                $bs_score = <STATE>;
                chomp($bs_score);
                $bs_bin = <STATE>;
                chomp($bs_bin);
                $bs_fft_ind = <STATE>;
                chomp($bs_fft_ind);
                $bs_chirp_rate = <STATE>;
                chomp($bs_chirp_rate);
                $bs_fft_len = <STATE>;
                chomp($bs_fft_len);
                $bg_score = <STATE>;
                chomp($bg_score);
                $bg_power = <STATE>;
                chomp($bg_power);
                $bg_chisq = <STATE>;
                chomp($bg_chisq);
                $bg_bin = <STATE>;
                chomp($bg_bin);
                $bg_fft_ind = <STATE>;
                chomp($bg_fft_ind);
                $bg_chirp_rate = <STATE>;
                chomp($bg_chirp_rate);
                $bg_fft_len = <STATE>;
                chomp($bg_fft_len);
                
				close(STATE) || die "---> Error: Cannot close state file\n";
				($prog_temp, $prog_value) = split(/=/, $prog);
				$unitprog = ($prog_value * 100);
				printf "%07.4f ", $unitprog;
				print "\% done ";
                }
			else
			{
				print "not found! ";
			}

            $rez = stat ($result_filename);
            if ($rez)
            {
                print "(finished - waiting for connection)\n";
            }
            else
            {
                print "(still needs to work)\n";
            }

			
		chdir "..";
		}
    	print "---> *** ALL DATA PACKETS LISTED ($num_setis) ***\n";
	}


    }
else
    {
	print "use: multisetismp.pl <command> [number]\n\n";
	print "Command: init     - make directories for multiple setis\n";
	print "         connect  - download data & send results (if any)\n";
	print "         work     - start to work!\n";
	print "         status   - display progress of seti packets\n";
	print " (new!)  brief    - display brief progress of seti packets\n";
	print " (new)   tar      - make tar archive of seti packets\n";
	print " (new)   untar    - unpack tar archive of seti packets\n";
	print "         del      - delete directories (only works if dirs are empty)\n";
	print "         wipe     - delete directories with files in dirs\n\n";
	print "Number:  (optional) number of seti packets for one session (default: $num_setis)\n";
    
	print "\n";
    }
exit 0;
